import 'dart:async';

import 'package:data_manage/data_manage.dart';
import 'package:data_manage/src/batch_throttle_aggregator/_index.dart';

abstract class IBatchThrottleAggregator<T> {
  IBatchThrottleDelegate<T> get delegate;

  bool get isConfirmInProgress;

  void add(T data);

  void forceConfirm();
}

abstract class IBatchThrottleDelegate<T> {
  Duration get durationIdleBeforeConfirm;

  bool willConfirm();

  void onAddData(T data);

  FutureOr<void> onConfirmBatch(AggregatedBatch<T> batch);

  void onError(Object? error, StackTrace trace);
}
